<template>
  <div 
    v-if="props.selectedDataPoint"
    class="bg-[#2B0A17] rounded-lg text-white w-64 overflow-hidden shadow-lg"
  >
    <div v-if="stylingCDM">
      <!-- Header -->
      <div class="flex justify-between items-center bg-[#4A0D2C] px-4 py-2">
        <div class="flex items-center">
          <span class="text-sm font-normal opacity-80">CDM: {{ props.selectedDataPoint?.id?.substring(0,15) }}</span>
        </div>
        <button @click="closePanel" class="text-lg hover:text-gray-300">×</button>
      </div>
      <!-- Details Grid -->
      <br>
      <div class="px-4 pb-4 space-y-4">
        <div v-if="props.selectedDataPoint?.arguments" class="space-y-4">
          <div class="flex flex-col">
            <span class="text-sm text-gray-400">Sender:</span>
            <span class="text-sm">{{ formatSender(props.selectedDataPoint.arguments.sender) }}</span>
          </div>
          <div class="flex flex-col">
            <span class="text-sm text-gray-400">Timestamp:</span>
            <span class="text-sm">{{ formatDate(props.selectedDataPoint.arguments.timestamp) }}</span>
          </div>
          <div class="flex flex-col">
            <span class="text-sm text-gray-400">Min Distance:</span>
            <span class="text-sm">{{ formatDistance(props.selectedDataPoint.arguments.md) }}</span>
          </div>
          <div class="flex flex-col">
            <span class="text-sm text-gray-400">Probability of Collision:</span>
            <span class="text-sm" :style="{ color: props.selectedDataPoint.color }">
              {{ formatProbability(props.selectedDataPoint.arguments.pc) }}
            </span>
          </div>
          <div class="flex flex-col">
            <span class="text-sm text-gray-400">Location:</span>
            <div class="text-sm">
              <div>Lat: {{ formatCoordinate(props.selectedDataPoint.lat) }}°</div>
              <div>Lng: {{ formatCoordinate(props.selectedDataPoint.lng) }}°</div>
              <div>Alt: {{ formatAltitude(props.selectedDataPoint.arguments.alt) }}</div>
            </div>
          </div>
        </div>
      </div>
    </div>

    <div v-if="!stylingCDM">
      <!-- Header -->
      <div class="flex justify-between items-center bg-[#4A0D2C] px-4 py-2">
        <div class="flex items-center">
          <span class="text-sm font-normal opacity-80">Report: {{ props.selectedDataPoint?.id?.substring(0,15) }}</span>
        </div>
        <button @click="closePanel" class="text-lg hover:text-gray-300">×</button>
      </div>
      <!-- Details Grid -->
      <br>
      <div class="px-4 pb-4 space-y-4">
        <div class="flex flex-col">
          <span class="text-sm text-gray-400">Predicted Time:</span>
          <span class="text-sm">{{ props.selectedDataPoint?.arguments?.timestamp }}</span>
        </div>
        <div class="flex flex-col">
          <span class="text-sm text-gray-400">Source:</span>
          <span class="text-sm">{{ props.selectedDataPoint?.arguments?.source }}</span>
        </div>
        <div class="flex flex-col">
          <span class="text-sm text-gray-400">Predicted Time:</span>
          <span class="text-sm">{{ props.selectedDataPoint?.arguments?.predictedTime }}</span>
        </div>
        <div class="flex flex-col">
          <span class="text-sm text-gray-400">Location:</span>
          <div class="text-sm">
            <div>Category: {{ props.selectedDataPoint?.arguments?.category }}</div>
            <div>Max Wind Speed: {{ props.selectedDataPoint?.arguments?.maxWindSpeed }} mph</div>
            <div>Population in >= Cat 1: {{ props.selectedDataPoint?.arguments?.populationInCat }}</div>
            <div>Population at Risk: {{ props.selectedDataPoint?.arguments?.populationAtRisk }}</div>
            <div>Number of countries involved: {{ props.selectedDataPoint?.arguments?.countries }}</div>
          </div>
        </div>
        <div class="flex flex-col">
          <span class="text-sm text-gray-400">Location:</span>
          <div class="text-sm">
            <div>Lat: {{ props.selectedDataPoint?.lat?.toFixed(4) }}°</div>
            <div>Lng: {{ props.selectedDataPoint?.lng?.toFixed(4) }}°</div>
          </div>
        </div>
      </div>
    </div>

  </div>
</template>

<script setup lang="ts">
import { ref } from 'vue'
import { useEventBus } from '@/components/UI/eventBus'
import type { CDMData } from '@/types/cdm'

const props = defineProps<{
  selectedDataPoint: CDMData | null
}>()

const eventBus = useEventBus()
const stylingCDM = ref(true)

const closePanel = () => {
  console.log('Closing panel')
  eventBus.emit('cdm-selected', null)
}

// Formatting functions
const formatSender = (sender: string): string => {
  return sender?.substring(0, 20) + '...' || 'Unknown'
}

const formatDate = (timestamp: string): string => {
  return timestamp || 'Unknown'
}

const formatDistance = (distance: number): string => {
  return distance ? `${(distance/1000).toFixed(2)}km` : 'Unknown'
}

const formatProbability = (probability: number): string => {
  return probability ? `${(probability/1000).toFixed(2)}%` : 'Unknown'
}

const formatCoordinate = (coord: number): string => {
  return coord?.toFixed(3) || 'Unknown'
}

const formatAltitude = (altitude: number): string => {
  return altitude ? `${(altitude/1000).toFixed(2)} km` : 'Unknown'
}
</script>

<style scoped>
.fade-enter-active,
.fade-leave-active {
  transition: opacity 0.3s ease;
}

.fade-enter-from,
.fade-leave-to {
  opacity: 0;
}
</style>
